-- wengwengweng

local Class = require("lib/vendor/classic")
local Audio = Class:extend()

local actions = {

	"play",
	"stop",
	"resume",
	"pause",
	"rewind",
	"seek",
	"setCone",
	"setPitch",
	"setVolume",
	"setLooping",
	"setDirection",
	"setPosition",
	"setVelocity",
	"setRolloff",
	"setRelative",
	"setVolumeLimits",
	"setAttenuationDistances"

}

local queries = {

	"clone",
	"getAttenuationDistances",
	"getChannels",
	"getCone",
	"getDirection",
	"getDuration",
	"getPitch",
	"getPosition",
	"getRolloff",
	"getType",
	"getVelocity",
	"getVolumn",
	"getVolumeLimits",
	"isLooping",
	"isPaused",
	"isPlaying",
	"isRelative",
	"isStopped"

}

function copy(o, actions, queries)

	for k, action in ipairs(actions) do

		o[action] = function(o, ...)

			o.src[action](o.src, ...)

			return o

		end

	end

	for k, query in ipairs(queries) do

		o[query] = function(o, ...)

			return o.src[query](o.src, ...)

		end

	end

end

function Audio:new(src)

	self:setSrc(src)
	copy(self, actions, queries)

end

function Audio:setSrc(src)

	assert(type(src) == "userdata")
	self.src = src

	return self

end

return Audio
