-- wengwengweng

local Class = require("lib/vendor/classic")
local Boxes = Class:extend()

local function bigger(box, size)

	return {

		pos = {

			x = box.pos.x - size,
			y = box.pos.y - size

		},

		size = {

			width = box.size.width + size * 2,
			height = box.size.height + size * 2

		}

	}

end

local function index(t, e)

	for k, v in pairs(t) do

		if (v == e) then return k end

	end

	return 0

end

function Boxes:new()

	self.boxes = {}

end

function Boxes:add(box)

	assert(type(box.pos) == "table")
	assert(type(box.size) == "table")
	table.insert(self.boxes, box)

	return self

end

function Boxes:remove(box)

	local i = index(self.boxes, box)

	if (i ~= 0) then

		table.remove(self.boxes, i)

	end

	return self

end

function Boxes:collides(b1, b2, dist)

	dist = dist or 0

	local b1 = bigger(b1, dist)
	local b2 = bigger(b2, dist)

	return b1.pos.x + b1.size.width >= b2.pos.x and
		  b1.pos.x <= b2.pos.x + b2.size.width and
		  b1.pos.y + b1.size.height >= b2.pos.y and
		  b1.pos.y <= b2.pos.y + b2.size.height

end

function Boxes:move(box, dx, dy)

	dx = dx or 0
	dy = dy or 0

	local expected = {

		pos = {

			x = box.pos.x + dx,
			y = box.pos.y + dy

		},

		size = box.size

	}

	for k, other in ipairs(self.boxes) do

		if (other ~= box) then

			if (self:collides(expected, other)) then

				return box.pos.x, box.pos.y

			end

		end

	end

	return expected.pos.x, expected.pos.y

end

return Boxes
