-- wengwengweng

local Class = require("lib/vendor/classic")
local Props = require("lib/core/props")
local Sprite = Class:extend()

Sprite:implement(Props.Pos)
Sprite:implement(Props.Size)
Sprite:implement(Props.Scale)
Sprite:implement(Props.Offset)
Sprite:implement(Props.Rot)
Sprite:implement(Props.Color)
Sprite:implement(Props.Box)

function Sprite:new(img)

	self:setPos(0, 0)
	self:setScale(1, 1)
	self:setOffset(0, 0)
	self:setRot(0)
	self:setColor({ 255, 255, 255, 255 })
	self:setImg(img)
	self:setSize(self.img:getWidth(), self.img:getHeight())

end

function Sprite:setImg(img)

	assert(type(img) == "userdata")
	self.img = img

	return self

end

function Sprite:setWidth(width)

	return self:setSize(width, width * self.img:getHeight() / self.img:getWidth())

end

function Sprite:setHeight(height)

	return self:setSize(height * self.img:getWidth() / self.img:getHeight(), height)

end

function Sprite:focused(x, y)

	if (x and y) then

		x = x + self.offset.x * self.size.width
		y = y + self.offset.y * self.size.height

		return x >= self.pos.x and x < self.pos.x + self.size.width and y >= self.pos.y and y <= self.pos.y + self.size.height

	end

	return false

end

function Sprite:update(dt) end

function Sprite:draw()

	love.graphics.setColor(self.color)

	love.graphics.draw(self.img,
				   self.pos.x,
				   self.pos.y,
				   self.rot,
				   self.size.width / self.img:getWidth() * self.scale.x,
				   self.size.height / self.img:getHeight() * self.scale.y,
				   self.offset.x * self.img:getWidth(),
				   self.offset.y * self.img:getHeight())

	love.graphics.setColor({255, 255, 255, 255})

end

return Sprite
