-- wengwengweng

local Class = require("lib/vendor/classic")
local Props = require("lib/core/props")
local Text = Class:extend()

Text:implement(Props.Pos)
Text:implement(Props.Size)
Text:implement(Props.Scale)
Text:implement(Props.Offset)
Text:implement(Props.Rot)
Text:implement(Props.Color)
Text:implement(Props.Box)

function Text:new(text)

	self:setPos(0, 0)
	self:setScale(1, 1)
	self:setOffset(0, 0)
	self:setRot(0)
	self:setColor({ 255, 255, 255, 255 })
	self:setText(text)
	self:setFont()

end

local function updateSize(t)

	if (t.font) then

		t.size = {

			width = t.font:getWidth(t.text),
			height = t.font:getHeight(t.text)

		}

	end

	return t

end

function Text:draw()

	love.graphics.setColor(self.color)
	love.graphics.setFont(self.font)

	love.graphics.print(self.text,
				   self.pos.x,
				   self.pos.y,
				   self.rot,
				   self.scale.x,
				   self.scale.y,
				   self.offset.x,
				   self.offset.y)

	love.graphics.setColor({255, 255, 255, 255})
	love.graphics.setFont(love.graphics.setNewFont(12))

end

function Text:center(width)

	if (type(width) == "number") then

		self.pos.x = (width - self.size.width) / 2

	end

	return self

end

function Text:setText(text)

	self.text = text or ""
	updateSize(self)

	return self

end

function Text:setFont(font)

	self.font = font or self.font or love.graphics.setNewFont(12)
	updateSize(self)

	return self

end

return Text
