-- wengwengweng

local Class = require("lib/vendor/classic")
local Event = Class:extend()

function Event:new(kind, time, action)

	self.type = kind
	self:setTime(time)
	self:setAction(action)
	self.step = 0
	self:start()

end

function Event:setTime(time)

	self.time = time or 0

	return self

end

function Event:setAction(action)

	self.action = action or function() end

	return self

end

function Event:start()

	self.stopped = false

	return self

end

function Event:stop()

	self.stopped = true

	return self

end

function Event:update(dt)

	if (not self.stopped) then

		self.step = self.step + dt

		if (self.type == "every") then

			if (self.step >= self.time) then

				self.step = 0
				self.action()

			end

		elseif (self.type == "after") then

			if (self.step >= self.time) then

				self.action()
				self:stop()

			end

		elseif (self.type == "during") then

			if (self.step <= self.time) then

				self.action()

			else

				self:stop()

			end

		end

	end

end

return {

	every = function(time, action) return Event("every", time, action) end,
	after = function(time, action) return Event("after", time, action) end,
	during = function(time, action) return Event("during", time, action) end

}
