-- wengwengweng

local Props = {}

Props.Pos = {}

function Props.Pos:setX(x)

	return self:setPos(x, self.pos.y)

end

function Props.Pos:setY(y)

	return self:setPos(self.pos.x, y)

end

function Props.Pos:setPos(x, y)

	self.pos = {}
	self.pos.x = x or self.pos.x or 0
	self.pos.y = y or self.pos.y or 0

	return self

end

function Props.Pos:getPos()

	return self.pos.x, self.pos.y

end

function Props.Pos:move(dx, dy)

	return self:setPos(self.pos.x + (dx or 0), self.pos.y + (dy or 0))

end

Props.Size = {}

function Props.Size:setWidth(w)

	return self:setSize(w, self.size.height)

end

function Props.Size:setHeight(h)

	return self:setSize(self.size.width, h)

end

function Props.Size:setSize(w, h)

	self.size = {}
	self.size.width = w or self.size.width or 0
	self.size.height = h or self.size.height or 0

	return self

end

function Props.Size:getSize()

	return self.size.width, self.size.height

end

Props.Scale = {}

function Props.Scale:setScale(x, y)

	if (x and not y) then

		return self:setScale(x, x)

	else

		self.scale = {}
		self.scale.x = x or self.scale.x or 1
		self.scale.y = y or self.scale.y or 1

	end

	return self

end

Props.Rot = {}

function Props.Rot:setRot(rot)

	self.rot = rot or self.rot or 0

	return self

end

Props.Offset = {}

function Props.Offset:setOffset(x, y)

	self.offset = {}
	self.offset.x = x or self.offset.x or 0
	self.offset.y = y or self.offset.y or 0

	return self

end

Props.Color = {}

function Props.Color:setColor(color)

	self.color = color or self.color or { 255, 255, 255, 255 }

	return self

end

Props.Box = {}

function Props.Box:collides(other)

	assert(type(other.pos) == "table")
	assert(type(other.size) == "table")

	return self.pos.x + self.size.width >= other.pos.x and
		  self.pos.x <= other.pos.x + other.size.width and
		  self.pos.y + self.size.height >= other.pos.y and
		  self.pos.y <= other.pos.y + other.size.height

end

function Props.Box:focused(x, y)

	if (x and y) then

		return x >= self.pos.x and x < self.pos.x + self.size.width and y >= self.pos.y and y <= self.pos.y + self.size.height

	end

	return false

end

return Props
