-- wengwengweng

local scale = {

	gw = love.graphics.getWidth(),
	gh = love.graphics.getHeight(),
	s = 1,
	translate = { x = 0, y = 0 }

}

function scale.init(w, h)

	scale.gw = w
	scale.gh = h
	scale.resize()

	return scale

end

function scale.resize()

	local sw = love.graphics.getWidth()
	local sh = love.graphics.getHeight()
	local gw = scale.gw
	local gh = scale.gh

	if sw / sh < gw / gh then

		scale.s = sw / gw
		gw = gw * scale.s
		gh = gh * scale.s
		scale.translate = { x = 0, y = math.abs(sh - gh) / 2 }

	else

		scale.s = sh / gh
		gw = gw * scale.s
		gh = gh * scale.s
		scale.translate = { x = math.abs(sw - gw) / 2, y = 0 }

	end

end

function scale.draw()

	love.graphics.translate(scale.translate.x, scale.translate.y)
	love.graphics.scale(scale.s, scale.s)

end

function scale.filter(x, y)

	x = x - scale.translate.x
	y = y - scale.translate.y
	x = x / scale.s
	y = y / scale.s

	return x, y

end

return scale
