-- wengwengweng

local Class = require("lib/vendor/classic")
local Props = require("lib/core/props")
local Sprite = require("lib/components/sprite")
local Timer = require("lib/components/timer")
local Bleed = Class:extend()

Bleed:implement(Props.Pos)
Bleed:implement(Props.Size)

function Bleed:new(x, y, w, h, max)

	self:setPos(x, y)
	self:setSize(w, h)
	self.max = max or 2000
	self.sprite = love.graphics.newSpriteBatch(assets.sprites.bleed, self.max, "static")
	self.drop = Sprite(assets.sprites.drop):setWidth(self.size.width)
	self.lastX = self.pos.x - self.size.width / 2
	self.lastY = self.pos.y
	self.drop:setPos(self.lastX + self.size.width / 2, self.lastY + self.size.height)

	self.timer = Timer.every(0.1, function()

		if (self.sprite:getCount() < self.max) then

			self:add()

		end

	end)

end

function Bleed:add()

	local dx = (love.math.random(2) * 2 - 3) * self.size.height / 2

	self.lastX = love.math.random(3) == 1 and self.lastX + dx or self.lastX
	self.lastY = self.lastY + self.size.height
	self.sprite:add(self.lastX - self.pos.x + self.size.width / 2, self.lastY - self.pos.y, 0, self.size.width, self.size.height)
	self.drop:setPos(self.lastX + self.size.width / 2, self.lastY + self.size.height)

end

function Bleed:draw()

	self.drop:draw()
	love.graphics.draw(self.sprite, self.pos.x, self.pos.y)

end

function Bleed:update(dt)

	self.timer:update(dt)

end

return Bleed
