-- wengwengweng

local Class = require("lib/vendor/classic")
local Text = require("lib/components/text")
local Timer = require("lib/components/timer")
local Props = require("lib/core/props")
local Bumgo = Class:extend()

Bumgo:implement(Props.Pos)
Bumgo:implement(Props.Size)

function Bumgo:new(x, y)

	self:setPos(x, y)
	self:setSize(220, 96)
	self.title = Text("BUMGO"):setPos(self:getPos()):setFont(assets.fonts.cavestory(32))
	self.texts = {}
	self:shake()

end

function Bumgo:shake()

	self.timer = Timer.during(0.2, function()

		self:change()

	end)

end

function Bumgo:change()

	local chars = "qwertyuiopasdfghjklzxcvbnm"
	local pos

	self.level = ""

	for i = 1, 8 do

		if (love.math.random(1, 3) == 1) then

			pos = love.math.random(string.len(chars))
			self.level = self.level .. string.sub(chars, pos, pos)

		else

			self.level = self.level .. love.math.random(0, 9)

		end

	end

	self:textize()

end

function Bumgo:textize()

	local p = love.math.random(string.len(self.level))
	local one = self.level
	local two = string.sub(self.level, 1, p)
	local three = string.sub(self.level, 1, p- 1)

	local function rC()

		local function r255()

			return love.math.random(2) == 1 and 0 or 255

		end

		local c = { r255(), r255(), r255() }

		if (c[1] + c[2] + c[3] == 255 * 3 or c[1] + c[2] + c[3] == 0) then

			return rC()

		end

		return c

	end

	self.texts[1] = Text(one):setPos(self.pos.x + 24, self.pos.y + 48):setFont(assets.fonts.cavestory(48))
	self.texts[2] = Text(two):setPos(self.pos.x + 24, self.pos.y + 48):setFont(assets.fonts.cavestory(48)):setColor(rC())
	self.texts[3] = Text(three):setPos(self.pos.x + 24, self.pos.y + 48):setFont(assets.fonts.cavestory(48))


end

function Bumgo:draw()

	self.title:draw()

	for k, text in ipairs(self.texts) do

		text:draw()

	end

end

function Bumgo:update(dt)

	self.timer:update(dt)

end

return Bumgo
