-- wengwengweng

local Class = require("lib/vendor/classic")
local Text = require("lib/components/text")
local Pixel = require("lib/components/pixel")
local Props = require("lib/core/props")
local Conjun = Class:extend()

Conjun:implement(Props.Pos)
Conjun:implement(Props.Size)

function Conjun:new(x, y)

	self:setPos(x, y)
	self:setSize(220, 132)
	self.title = Text("CONJUN"):setPos(self.pos.x, self.pos.y):setFont(assets.fonts.cavestory(32))
	self.level = Pixel(8, 8):setX(self.pos.x + 120):setColor({255, 0, 0})
	self.wave = {}

end

function Conjun:drawGrid()

	local x, y = self:getPos()
	local w, h = self:getSize()

	love.graphics.setLineWidth(1)
	love.graphics.setColor({ 255, 255, 255, 60 })

	for i = 40, h, 16 do

		love.graphics.line(x, y + i, x + w, y + i)

	end

	love.graphics.setColor({ 255, 255, 255, 255 })

end

function Conjun:draw()

	self.title:draw()
	self:drawGrid()
	love.graphics.points(self.wave)
	self.level:draw()

end

function Conjun:update(dt)

	local t = love.timer.getTime() * 0.8
	local f = 1.6

	self.level:setY(self.pos.y + 80 + math.sin((t + math.rad(126)) * f) * 24)
	self.wave = {}

	for i = 24, self.size.width - 24 do

		self.wave[#self.wave + 1] = self.pos.x + i
		self.wave[#self.wave + 1] = self.pos.y + 80 + math.sin((t + math.rad(i)) * f) * 24

	end

end

return Conjun
