-- wengwengweng

local Class = require("lib/vendor/classic")
local Props = require("lib/core/props")
local Pixel = require("lib/components/pixel")
local Eye = require("lib/entities/eye")
local Nose = require("lib/entities/nose")
local Mouth = require("lib/entities/mouth")
local Face = Class:extend()

Face:implement(Props.Pos)
Face:implement(Props.Size)

function Face:new(x, y)

	self:setPos(x, y)
	self:setSize(4800, 4800)
	self.back = Pixel(self.size.width, self.size.height):setColor({ 241, 206, 176, 255 })
	self.organs = {}
	self:organize()

end

function Face:update(dt)

	for k, organ in ipairs(self.organs) do organ:update(dt) end

end

function Face:draw()

	self.back:draw()
	for k, organ in ipairs(self.organs) do organ:draw() end

end

function Face:organize()

	-- spawn organs

	local function add(o)

		self.organs[#self.organs + 1] = o

	end

	add(Nose(60, 0))
	add(Nose(1080, -120))
	add(Nose(720, 720))
	add(Nose(1600, 640))
	add(Nose(2000, 40))
	add(Nose(2420, 620))
	add(Nose(3100, 420))
	add(Nose(3060, 1190))
	add(Nose(3980, -80))
	add(Nose(50, 1440))
	add(Nose(850, 1330))
	add(Nose(2040, 1510))
	add(Nose(4480, 660))
	add(Nose(2060, 2330))
	add(Nose(2860, 2150))
	add(Nose(3990, 1740))
	add(Nose(1230, 2050))
	add(Nose(180, 2160))
	add(Nose(1420, 2750))
	add(Nose(440, 3130))
	add(Nose(1290, 3270))
	add(Nose(2270, 3170))
	add(Nose(3040, 2740))
	add(Nose(4280, 2540))
	add(Nose(2120, 3970))
	add(Nose(3270, 3650))
	add(Nose(1460, 4170))
	add(Nose(620, 3920))
	add(Nose(4270, 4350))

	add(Eye(440, 320))
	add(Eye(1120, 480))
	add(Eye(-160, 840))
	add(Eye(1580, 180))
	add(Eye(320, 1120))
	add(Eye(1880, 1080))
	add(Eye(2420, -160))
	add(Eye(2720, 240))
	add(Eye(2860, 720))
	add(Eye(3510, 130))
	add(Eye(3380, 870))
	add(Eye(1500, 1430))
	add(Eye(2460, 1360))
	add(Eye(4120, 360))
	add(Eye(4030, 980))
	add(Eye(2320, 2030))
	add(Eye(3440, 1920))
	add(Eye(3310, 2420))
	add(Eye(4240, 2100))
	add(Eye(1090, 1640))
	add(Eye(-40, 1850))
	add(Eye(690, 2060))
	add(Eye(1020, 2480))
	add(Eye(1620, 2350))
	add(Eye(120, 2800))
	add(Eye(1700, 3100))
	add(Eye(860, 3460))
	add(Eye(1630, 3650))
	add(Eye(2560, 2870))
	add(Eye(3700, 2740))
	add(Eye(3430, 3160))
	add(Eye(2580, 3800))
	add(Eye(3900, 3520))
	add(Eye(2960, 4190))
	add(Eye(1760, 4510))
	add(Eye(980, 4280))
	add(Eye(3540, 4590))
	add(Eye(40, 4180))
	add(Eye(250, 3760))

	add(Mouth(20, 480))
	add(Mouth(880, 180))
	add(Mouth(1200, 880))
	add(Mouth(2060, 400))
	add(Mouth(3040, 20))
	add(Mouth(2560, 1000))
	add(Mouth(3620, 520))
	add(Mouth(520, 1680))
	add(Mouth(2880, 1660))
	add(Mouth(1700, 1870))
	add(Mouth(4540, 200))
	add(Mouth(3660, 1290))
	add(Mouth(2570, 2460))
	add(Mouth(3690, 2260))
	add(Mouth(470, 2430))
	add(Mouth(1990, 2680))
	add(Mouth(940, 2920))
	add(Mouth(-20, 3350))
	add(Mouth(1130, 3750))
	add(Mouth(2090, 3480))
	add(Mouth(4120, 3070))
	add(Mouth(2810, 3310))
	add(Mouth(3690, 3920))
	add(Mouth(2390, 4340))
	add(Mouth(490, 4540))

end

return Face
