-- wengwengweng

local Class = require("lib/vendor/classic")
local Sprite = require("lib/components/sprite")
local Props = require("lib/core/props")
local Hand = Class:extend()

Hand:implement(Props.Pos)

function Hand:new()

	self.left = Sprite(assets.sprites.left):setWidth(480)
	self.right = Sprite(assets.sprites.right):setWidth(480)
	self:setPos(0, 0)
	self:release()

end

function Hand:move(dx, dy)

	Props.Pos.move(self, dx, dy)
	self:setPos(self:getPos())

end

function Hand:setPos(x, y)

	Props.Pos.setPos(self, x, y)
	self.left:setPos(self.pos.x, self.pos.y)
	self.right:setPos(self.pos.x, self.pos.y)

end

function Hand:draw()

	self.left:draw()
	self.right:draw()

end


function Hand:squeeze()

	-- squeeze hand

	self.left:setOffset(1, 0.5)
	self.right:setOffset(0, 0.5)

	return self

end

function Hand:release()

	-- release hand

	self.left:setOffset(1.1, 0.5)
	self.right:setOffset(-0.1, 0.5)

	return self

end

return Hand
