-- wengwengweng

local Class = require("lib/vendor/classic")
local Audio = require("lib/components/audio")
local Timer = require("lib/components/timer")
local Animation = require("lib/components/animation")
local Bleed = require("lib/entities/bleed")
local Props = require("lib/core/props")
local Pimple = Class:extend()

Pimple:implement(Props.Pos)

function Pimple:new(x, y, w)

	self:setPos(x, y)
	self.popped = false
	self.sprite = Animation()
	self.sprite:add("spring", assets.sprites.pimple, 4, 1):play("spring"):loop()
	self.sprite:add("popped", assets.sprites.pimple_pop, 4, 0.25)
	self.sprite:setWidth((w or 32)):setPos(self:getPos()):setOffset(0.5, 0.5)
	self.sound = Audio(assets.audio.pop)

end

function Pimple:update(dt)

	self.sprite:update(dt)
	if (self.blood) then self.blood:update(dt) end
	if (self.bleed) then self.bleed:update(dt) end

end

function Pimple:draw()

	self.sprite:draw()
	if (self.blood) then self.blood:draw() end
	if (self.bleed) then self.bleed:draw() end

end

function Pimple:focused(x, y)

	return self.sprite:focused(x, y)

end

function Pimple:pop(height)

	-- play sound
	-- play the pop animation

	local x = self.pos.x - self.sprite.size.width * 0.2
	local y = self.pos.y
	local w = self.sprite.size.width * 0.375
	local h = w / 6
	local max = height and math.ceil((height - y) / h) or nil

	self.popped = true
	self.sound:play()
	self.sprite:play("popped"):unloop()
	self.blood = Animation()
	self.blood:add("burst", assets.sprites.blood, 2, 0.5)
	self.blood:play("burst")
	self.blood:setWidth(self.sprite.size.width * 2):setPos(self:getPos()):setOffset(0.5, 0.5)
	self.bleed = Bleed(x, y, w, h, max)

end

return Pimple
